#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;
use Digest::MD5 qw(md5_hex);

require 'lib/cgilib.pl';
require 'lib/user.pl';

my $cgi = CGI->new;

my $uid;
my $name;
my $password;

$name = $cgi->param('name');
$password = $cgi->param('password');

if ($name eq "") {
	error("Empty user name!");
	exit;
}

if ($password eq "") {
	error("Empty password!");
	exit;
}

if ($name =~ /[^\w]/) {
	error("Invalid user name!");
	exit;
}

if ($password =~ /[^\x21-\x7e]/) {
	error("Invalid password!");
	exit;
}

$uid = user::get_uid($name);

if ($uid ne "") {
	error("$name is exist!");
	exit;
}

$password = md5_hex($password);
if (user::add($name, $password) < 0) {
	error("Cannot add user!");
	exit;
}

cgilib::header($cgi, "Succeed");
	print <<"EOD";
<h1>Register $name !</h1>
<p><a href="login.cgi">Go to Login</a></p>
EOD
cgilib::footer($cgi);

sub error {
	my $message;

	($message) = @_;

	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>$message</h1>
<p><a href="register.cgi">Retry</a></p>
EOD
	cgilib::footer($cgi);
}
