#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;
use Digest::MD5 qw(md5_hex);

require 'lib/cgilib.pl';
require 'lib/user.pl';

my $cgi = CGI->new;

my $uid;
my $name;
my $password;

$uid = user::get_uid($cgi->param('name'));
if ($uid eq "") {
	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>Unknown User!</h1>
<p><a href="login.cgi">Login</a></p>
EOD
	cgilib::footer($cgi);
	exit;
}

($uid, $name, $password) = user::readfile($uid);
if ($password ne md5_hex($cgi->param('password'))) {
	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>Invalid Password!</h1>
<p><a href="login.cgi">Login</a></p>
EOD
	cgilib::footer($cgi);
	exit;
}

my $session = CGI::Session->new("driver:File", undef, { Directory => './session' });

$session->expire('+60m');
$session->param('uid', $uid);
$session->flush();

my $session_id = $session->id;

my $cookie = $cgi->cookie(-name=>'CGISESSID', -value=>$session_id);
print $cgi->redirect(-uri=>"home.cgi", -cookie=>$cookie);
