#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;
use POSIX;

require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>Invalid User!</h1>
<p><a href="login.cgi">Login</a></p>
EOD
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

cgilib::header($cgi, "History");
cgilib::menu($session_id, $name);

print <<"EOD";
<table>
<thead>
<tr>
<th>Clear Time</th>
<th>Name</th>
<th>Genre</th>
<th>Score</th>
<th>Title</th>
</tr>
</thead>
<tbody>
EOD

my $qid;
my $u;
my $uqid;
my %clear;
my $t;
my $name;
my $genre;
my $score;
my $title;

foreach $u (user::list()) {
	foreach $qid (question::clear_list($u)) {
		$uqid = $u . "\n" . $qid;
		$clear{$uqid} = question::get_time($u, $qid);
	}
}

foreach $uqid (sort { $clear{$b} <=> $clear{$a} } keys(%clear)) {
	$t = strftime "%Y-%m-%d %H:%M:%S", localtime $clear{$uqid};
	($u, $qid) = split(/\n+/, $uqid);
	$name = user::get_name($u);
	$genre = question::get_genre($qid);
	$score = question::get_score($qid);
	$title = question::get_title($qid);
	print <<"EOD";
<tr>
<td style="text-align: center;">$t</td>
<td style="text-align: center;">$name</td>
<td style="text-align: center;">$genre</td>
<td style="text-align: center;">$score</td>
<td style="text-align: center;"><a href="question.cgi?qid=$qid">$title</a></td>
</tr>
EOD
}

print "</tbody>\n";
print "</table>\n";
cgilib::footer($cgi);
