#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;
use POSIX;

require 'config.pl';
require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>Invalid User!</h1>
<p><a href="login.cgi">Login</a></p>
EOD
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

cgilib::header($cgi, "Home");
cgilib::menu($session_id, $name);

if ($config::begin_time gt strftime "%Y-%m-%d %H:%M", localtime) {
	print "<p>The competition begins at $config::begin_time. Please wait...</p>\n";
	cgilib::footer($cgi);
	exit;
}

if ($config::end_time le strftime "%Y-%m-%d %H:%M", localtime) {
	print "<p>The competition has ended at $config::end_time.</p>\n";
}

print <<"EOD";
<table>
<thead>
<tr>
<th>#</th>
<th>Genre</th>
<th>Score</th>
<th>Title</th>
<th>Status</th>
</tr>
</thead>
<tbody>
EOD

my $num = 0;
my $qid;

my $genre;
my $score;
my $title;
my $question;
my @answers;

my $clear;
my $total_score = 0;

my @qid_list = question::list();
foreach $qid (@qid_list) {
	($genre, $score, $title, $question, @answers) = question::readfile($qid);

	$num++;

	if (question::is_clear($uid, $qid)) {
		$clear = "Clear";
	} else {
		$clear = "";
	}

	print <<"EOD";
<tr>
<td style="text-align: center;">$num</td>
<td style="text-align: center;">$genre</td>
<td style="text-align: center;">$score</td>
<td><a href="question.cgi?qid=$qid">$title</a></td>
<td style="text-align: center;">$clear</td>
</tr>
EOD
}

print "</tbody>\n";
print "</table>\n";

$total_score = question::total_score($uid);

print "<p>Your total score is ${total_score}.</p>\n";

cgilib::footer($cgi);
