package cgilib;

sub header {
	my ($cgi, $title) = @_;

	print $cgi->header(-charset=>'UTF-8');
	print <<"EOD";
<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>$title</title>
<link rel="stylesheet" type="text/css" href="style.css">
</head>
<body>
EOD
}

sub footer {
	print "</html>\n";
}

sub error {
	my ($cgi, $message) = @_;
	header($cgi, "Error");
	print <<"EOD";
<h1>$message</h1>
<p><a href="login.cgi">Retry</a></p>
EOD
	footer($cgi);
}

sub menu {
	my ($session_id, $name) = @_;

	print <<"EOD";
<h1>$name</h1>
<table class="menu"><tr>
<td>Menu:</td>
<td><a href="home.cgi">Home</a></td>
<td><a href="history.cgi">History</a></td>
<td><a href="ranking.cgi">Ranking</a></td>
<td><a href="popular.cgi">Popular</a></td>
<td><a href="progress.cgi">Progress</a></td>
<td><a href="logout.cgi">Logout</a></td>
</tr></table>
EOD
}

1;
