#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;

require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>Invalid User!</h1>
<p><a href="login.cgi">Login</a></p>
EOD
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

$session->delete();

my $cookie = $cgi->cookie(-name=>'CGISESSID', -expires=>'-1d');
print $cgi->redirect(-uri=>"login.cgi", -cookie=>$cookie);
