#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;

require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>Invalid User!</h1>
<p><a href="login.cgi">Login</a></p>
EOD
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

cgilib::header($cgi, "Popular");
cgilib::menu($session_id, $name);

print <<"EOD";
<table>
<thead>
<tr>
<th>Genre</th>
<th>Score</th>
<th>Title</th>
<th>Correct</th>
</tr>
</thead>
<tbody>
EOD

my $qid;
my $u;
my %correct;
my @qid_list = question::list();
my @uid_list = user::list();

foreach $qid (@qid_list) {
	$correct{$qid} = 0;
	foreach $u (@uid_list) {
		if (question::is_clear($u, $qid)) {
			$correct{$qid}++;
		}
	}
}

my $genre;
my $score;
my $title;
my $question;
my @answers;

foreach $qid (sort { $correct{$b} <=> $correct{$a} } keys(%correct)) {
	($genre, $score, $title, $question, @answers) = question::readfile($qid);
	print <<"EOD";
<tr>
<td style="text-align: center;">$genre</td>
<td style="text-align: center;">$score</td>
<td><a href="question.cgi?qid=$qid">$title</a></td>
<td style="text-align: center;">$correct{$qid}</td>
</tr>
EOD
}

print "</tbody>\n";
print "</table>\n";
cgilib::footer($cgi);
