#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;
use POSIX;

require 'config.pl';
require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>Invalid User!</h1>
<p><a href="login.cgi">Login</a></p>
EOD
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

my $qid = $cgi->param('qid');
if (!question::is_valid($qid)) {
	cgilib::header($cgi, "Error");
	cgilib::menu($session_id, $name);
	print "<h1>Invalid Question!</h1>\n";
	cgilib::footer($cgi);
	exit;
}

my $genre;
my $score;
my $title;
my $question;
my @answers;

($genre, $score, $title, $question, @answers) = question::readfile($qid);

cgilib::header($cgi, "Question");
cgilib::menu($session_id, $name);

$question =~ s/\n$//;

print <<"EOD";
<table>
<tbody>
<tr><th>Genre</th><td>$genre</td></tr>
<tr><th>Score</th><td>$score</td></tr>
<tr><th>Title</th><td>$title</td></tr>
<tr><th>Question</th><td><pre>$question</pre></td>
<tr>
<th>Answer</th>
EOD

if (!question::is_clear($uid, $qid)) {
	if ($config::end_time gt strftime "%Y-%m-%d %H:%M", localtime) {
		print <<"EOD";
<td><form action="submit.cgi" method="post">
<input type="hidden" name="qid" value="$qid">
<input type="text" name="reply" maxlength="128">
<input type="submit" value="Submit">
</form></td>
EOD
	}
	else {
		print "<td>Closed</td>\n";
	}
}
else {
	print "<td>Already answered</td>\n";
}

print <<"EOD";
</tr>
</tbody>
</table>
EOD

cgilib::footer($cgi);
