#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;

require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print <<"EOD";
<h1>Invalid User!</h1>
<p><a href="login.cgi">Login</a></p>
EOD
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

cgilib::header($cgi, "Ranking");
cgilib::menu($session_id, $name);

print <<"EOD";
<table>
<thead>
<tr>
<th>Name</th>
<th>Score</th>
</tr>
</thead>
<tbody>
EOD

my $u;
my $n;
my %score;
my @uid_list = user::list();

foreach $u (@uid_list) {
	$score{$u} = question::total_score($u);
}

foreach $u (sort { $score{$b} <=> $score{$a} } keys(%score)) {
	$n = user::get_name($u);
	print <<"EOD";
<tr>
<td style="text-align: center;">$n</td>
<td style="text-align: center;">$score{$u}</td>
</tr>
EOD
}

print "</tbody>\n";
print "</table>\n";
cgilib::footer($cgi);
